############################################################
#                                                          #
#                 Loop Ordinary Kriging                    #
#                                                          #
############################################################

print("Loop Universal Kriging")
# Jan: els seguents tres paràmetres han d'estar al config file. El cosi no sempre passa per aqui i són variables q es fan servir a altres llocs (e.g., al UK) 
compute_in_UTM        <- TRUE #We want to transform the coordinates from CSR to UTM, it is faster in Universal Kriging
crs_model_utm         <- "+proj=utm +zone=31 +ellps=intl +units=m +no_defs"
crs_model             <- "+proj=longlat +datum=WGS84 +ellps=WGS84 +towgs84=0,0,0" #coordinates sistem
#les crs poden anar al config file, millor deixar crs_latlon i crs_utm per claretat

if(time_resolution=="hourly"){
  length_loop=nrow(date_times)

  #LOOCV_total and llista_uk_total is created empty to fill it later with LOOCV and raw model data respectivelly
  llista_uk_total           <- matrix(NA,ncol=nrow(local_stations@data),nrow=0) #list(length=nrow(date_times)) #we will have a large list with a data.frame for each hour
  #colnames(llista_uk_total) <- local_stations$ref_obs #we want a matrix with empty data and the name of stations
  colnames(llista_uk_total) <- local_stations@data$code #gene
  
}else{
  #Jan length_loop no pot estar definit aqui, ja q el codi no sempre passa per aqui i es necessita a altres llocs
    length_loop=length(dates)
  
  #generating a data.frame wih the information about local stations:
  cols              <- colnames(df_obs_sub[,1:(ncol(df_obs_sub)-1)]) #same as: colnames(subset(df_obs_sub, select = -Date))
  selection         <- local_stations@data$code %in% cols
  selected_stations <- local_stations[selection, ]
  new_df            <- data.frame(coords = selected_stations@coords, data = selected_stations@data)
  
  
  # prova tropecientosmil per saber quina es la dif:
  vars_local       <- as.character(local_stations@data$code)
  vars_df          <- names(df_obs_sub)[1:(length(names(df_obs_sub))-1)]
  vars_comunes     <- intersect(vars_local, vars_df)
  #num_vars_comunes <- length(vars_comunes)
  
  
  # Select only the stations that are also in vars_comunes
  local_stations <- subset(local_stations,with(local_stations@data, code %in% vars_comunes))
  
  #No entenc perque les dues linies aquestes no van, es com que la matriu no s'inicialitza, pero bueno funciona amb el data.frame
  #llista_uk_total            <- matrix(NA,ncol=length(vars_comunes),nrow=0) #list(length=nrow(date_times)) #we will have a large list with a data.frame for each hour
  #colnames(llista_uk_total)  <- vars_comunes #nope
  
  llista_uk_total           <- data.frame(matrix(NA, ncol = length(vars_comunes), nrow = 0))
  colnames(llista_uk_total) <- local_stations@data$code
  
  # -------
  # To know if we have an observated local station that its not in local stations data frame, we gonna create a new data frame with the names of the variables
  different_names <- setdiff(names(df_obs_sub),vars_comunes) # which names in df_obs_sub are not in vars_comunes, ojo! l'ordre sí importa
  # Print the different names
  print(different_names)
  
}


#starting OK and LOOCV:
for (hour in 1:length_loop) {
  print(paste0("loop UK number:",hour))
  df_model <- model[,,hour]
  
  #if all the model for a certain hour is nan we cannot apply UK
  if (sum(is.nan(df_model))!=length(df_model)){
    
    # #print(df_obs_all[hour,1])
    # if(time_resolution=="hourly"){
    #   df_obs   <- df_obs_sub[hour,-1] 
    # }else{
    #   df_obs <- df_obs_sub[, !names(df_obs_sub) %in% different_names]
    #   #df_obs <- subset(df_obs_sub, select = -Date) #OJO NO ESTAN ORDENADES COM A LA LLISTA UK!!!
    #   df_obs <- df_obs[hour,]
    # }
    
    #sum(is.na(df_obs)). Hem de marcar-nos fins a quantes observacions fem l'UK, i en cas de no ternir-ne suficients si agafar un variograma del UK previ o bé saltar a l'else
    
    # 1. Interpolate model values at obs locations
    #    1.1. Set spatialpointsdataframe
    #raw model:
    df_model                  <- data.frame(lat=lat_model,lon=lon_model,pollutant=sapply(df_model,as.matrix))
    coordinates(df_model)     <- ~lon+lat
    sp::proj4string(df_model) <- crs_model
    
    #config the coordinates in UTM
    if (compute_in_UTM) {
      df_model <- spTransform(df_model, sp::CRS(crs_model_utm))
    }
    
    #observations:
    df_obs    <- data.frame(lat=local_stations@coords[,2],lon=local_stations@coords[,1],pollutant=NA,code=local_stations@data$code)

    # If we don't have an observation or a negative value we remove it 
    #In OK we don't mind about the values of observations
    #df_obs                     <- na.omit(df_obs) 
    #df_obs[df_obs$pollutant<0,"pollutant"] <- NA
    #df_obs                     <- na.omit(df_obs)
    
#Jan : aqui no ens cal el valor de la observació, millor fer això al UK
    #To avoid what we suppose wrong observations, we will subtitute the values higher than limit microg/m3
    # w <- length(which(df_obs$pollutant>limit))
    # if(w>=1){
    #   df_obs[df_obs$pollutant>limit,"pollutant"] <- limit
    #   print(paste0("The observations has been modified to exceed ", limit, " límit value. The number of observations modified are : ", w, " in the hour:", hour))
    # }
    # 
    coordinates(df_obs)        <- ~lon+lat
    sp::proj4string(df_obs)    <- crs_model
    
    #config the coordinates in UTM
    if (compute_in_UTM) {
      df_obs <- spTransform(df_obs, sp::CRS(crs_model_utm))
    }
    
    #A ver,substitueixo els NA i els valors <0 per 0. EN principi no afecta el OK no? si total interpolem model a estació independentment del seu valor
    # No fa falta, primer pk es un OK i no ens afecta el valor de l'observació real, i segon, si posem 0 després utilitzant el filling amb el IA no sabrem distingir els NA dels 0
    #if(any(is.na(df_obs@data)) | isTRUE(df_obs@data$pollutant<0)){
     # df_obs$pollutant<- ifelse(is.na(df_obs$pollutant)|df_obs$pollutant<0,0,df_obs$pollutant)
      #print(paste0("Negative or NA in the observations has been substituted by zero in the hour:", " ", hour))
    #}
    
    #    1.2 Compute Variogram
    set.seed(1) #we are picking random points in the next line, set.seed permits us to have same points in each loop
    pick_random_points        <- sample(1:nrow(df_model),1000)
    pollutant.fit_ok          <- automap::autofitVariogram(formula=pollutant~1, input_data=df_model[pick_random_points,],model="Ste")
    # Hem posat model='Ste' pk la segona hora del 01/06/2021 peta el variograma, mirar bé perque no s'ajusa
    if (!file.exists(variogram_ok)) {
      saveRDS(pollutant.fit_ok,variogram_ok)
    }
    #    1.3 Compute ordinary Kriging
    
    #Del model interpolo cap a les coordenades de les obs 'OK'
    ok_gstat <- gstat(formula=pollutant~1, data = df_model, model = pollutant.fit_ok$var_model, nmax=100)
    
    #Interpolacio del model a les coordenades del conjunt
    OK       <- predict(object=ok_gstat, newdata=df_obs)
    
    #If the variogram has singular matrix then it produces NAN's, so in that case we take a good Variogram instead:
    if(any(is.na(OK@data$var1.pred))){
      print("WARNING: VARIOGRAM DIVERGED! Using a precalculated VARIOGRAM")
      pollutant.fit_ok=readRDS(variogram_ok)
      ok_gstat <- gstat(formula=pollutant~1, data = df_model, model = pollutant.fit_ok$var_model, nmax=100)
      
      #Interpolacio del model a les coordenades del conjunt
      OK <-predict(object=ok_gstat, newdata=df_obs)
    }
    
    llista_uk_h           <- matrix(data=OK$var1.pred, nrow=1)
    colnames(llista_uk_h) <- df_obs$code
    
    llista_uk_total <-  plyr::rbind.fill(as.data.frame(llista_uk_total), as.data.frame(llista_uk_h))
    
  }
  
  else{
    llista_uk_h           <- matrix(data=NA, nrow=1,ncol=nrow(local_stations@data))
    colnames(llista_uk_h) <- local_stations@data$code
    llista_uk_total       <- plyr::rbind.fill(llista_uk_total,as.data.frame(llista_uk_h))
  }
}
#Jan: llista_uk_total ja és un data.frame, no?
llista_uk_total_df       <- as.data.frame(llista_uk_total)

#Jan: Així com està, dates s'està afegint a la última columna. Amb la resta de df estem posant dates a la primera. ojo
if(time_resolution=="hourly"){
  llista_uk_total_df$dates <- date_times$date 
}else{
  llista_uk_total_df$dates <- df_obs_sub$Date
}

# Jan: llista_uk_total_df.rds renamed to model_raw_at_AQMS.rds
if (save_OK){
  saveRDS(object=llista_uk_total_df, file=paste0(save_result,"llista_uk_",pollutant,"_df.rds"))
  print("Llista OK saved")
} else {
  print("Llista OK have not been saved")
}
